/*
  CPP_CONTEST=2018Junio
  CPP_PROBLEM=G
  CPP_LANG=CPP+MPI
  CPP_PROCESSES_PER_NODE=calisto 4
*/

#include <stdlib.h>
#include <stdio.h>
#include <mpi.h>

extern void escribir(int *,int,int);

void copiar(int n,int *vd,int *vo) 
//se copia el vector vo en el vd
{
  int i;
  for(i=0;i<n;i++)
    vd[i]=vo[i];
}

int back(int n,int *A,int fila,int columna)
{
  int valor;
  if(fila==n-1)
    return A[fila*n+columna];
  else
  {
    int maximo=0;
    if(columna!=0)
    {
      valor=A[fila*n+columna]+back(n,A,fila+1,columna-1);
      if(valor>maximo)
        maximo=valor;
    }
    if(columna!=n-1)
    {
      valor=A[fila*n+columna]+back(n,A,fila+1,columna+1);
      if(valor>maximo)
        maximo=valor;
    }
    valor=A[fila*n+columna]+back(n,A,fila+1,columna);
    if(valor>maximo)
      maximo=valor;
    return maximo;
  }
}

int  sec(int n,int *A,int nodo,int np)
{
  MPI_Status *status;
  MPI_Bcast(&n,1,MPI_INT,0,MPI_COMM_WORLD);
  if(nodo!=0)
    A=new int[n*n];
  MPI_Bcast(A,n*n,MPI_INT,0,MPI_COMM_WORLD); //se mandan los datos a todos los procesos

  int VOA=0; //valor óptimo actual de cada proceso
  
  for(int i=nodo;i<n;i+=np) //cada proceso realiza varios backtracking
  {
     int valor=0; //para almacenar el valor calculado
     valor=back(n,A,0,i); //se pasa la fila y columna por lo que se sigue haciendo el backtracking
     if(valor>VOA)
     {
        VOA=valor;
     }
#ifdef DEBUG
  printf("columna %d , valor %d , optimo %d\n",i,valor,VOA);
#endif
  }
  if(nodo==0) //el cero recibe los óptimos de todos
  {
    int valor;
    for(int i=1;i<np;i++)
    {
      MPI_Recv(&valor,1,MPI_INT,i,40,MPI_COMM_WORLD,status);
      if(valor>VOA)
        VOA=valor;
    }
  }
  else
  {
     MPI_Send(&VOA,1,MPI_INT,0,40,MPI_COMM_WORLD);
     delete[] A;
  }
  return VOA;
}

